using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

// natuerlich verwenden wir die URSPRUENGLICH definierte schnittstelle(n)
// die noetigen Typen (laufzeit) sind bestandteil des hosts/containers und werden mit diesem installiert und registriert
using ECtiClientLib;

// Create Handler in DotNET
// - create new ClassLibrary Project
// change [assembly: ComVisible(false)] in "AssemblyInfo.cs" to true
// add reference to ECtiClient.tlb
// derive your class from IClientAddIn and implement it using "implement interface"
// select the "Register for COM interop" check box via Project->Properties
// regasm DOTNETHandler.dll

namespace DOTNETHandler
{
	// das ist eine CtxMnuHandler implementierung in .Net
	// Using .Net (CLR Managed) Classes in Win32 Applications, http://www.mazecomputer.com/sxs/help/clrclass.htm
	[
		Guid("91801345-BC47-4794-8DF0-B86F1E546BF8"),
		ClassInterface(ClassInterfaceType.None)
	]
	public class MyCtxMnuHandler : ECtiClientLib.IClientAddIn, ECtiClientLib.ICtxMnuHandler
	{
	#region IClientAddIn Members

	public void GetAbout(out string bstrAbout, out string bstrInfo)
	{
		bstrAbout = "ESTOS GmbH 2014";
		bstrInfo = "DotNet Handler";
	}

	// do not store the given Application Object
	public void OnLoad(object pClientApplication)
	{
	}

	public void OnUnload()
	{
		// with the following code you satisfy the basic COM requirements about deterministic live cycle control via AddRef/Release
		/* GC.Collect();
		GC.WaitForPendingFinalizers(); */
	}

	#endregion

	#region ICtxMnuHandler Members

	public void OnCtxMenuCreate(object pCmdBar, object pContact)
	{
		ECtiClientLib.IPCCmdBar pPCCmdBar = (ECtiClientLib.IPCCmdBar)pCmdBar;
		pPCCmdBar.Add("{6A108A4F-E4CD-4d99-BAEF-AA4FF35A457B}", 1, "DotNET Handler for C#", 0, "");
	}

	public void OnCtxMenuItemClicked(int nCmdID, object pContact)
	{
		System.Windows.Forms.MessageBox.Show("OnCtxMenuItemClicked", "DotNET Handler for C#");
	}

	#endregion
	}
}
