using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MultiSink
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            MultiSink.Program.m_app.OnCallDialing += new ENETTSCLib._IApplicationEvents_OnCallDialingEventHandler(App_OnCallEvent);
            MultiSink.Program.m_app.OnCallDestroyed += new ENETTSCLib._IApplicationEvents_OnCallDestroyedEventHandler(App_OnCallEvent);
        }

        void App_OnCallEvent(object pCall)
        {
            ENETTSCLib.ICall spCall = (ENETTSCLib.ICall)pCall;
            label1.Text = string.Format("{0}: {1}", spCall.State.ToString(), spCall.LocalNumber);
            label2.Text = string.Format("{0}: {1}", spCall.ParentLine.Number, spCall.ParentLine.DisplayName);
        }

        private void newFormToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form1 aForm = new Form1();
            aForm.Show();
        }
    }
}