// EProCallExt.cpp : Implementation of DLL Exports.


#include "stdafx.h"
#include "resource.h"
#include "EProCallExt.h"


class CEProCallExtModule : public CAtlDllModuleT< CEProCallExtModule >
{
public :
	DECLARE_LIBID(LIBID_EProCallExtLib)
	DECLARE_REGISTRY_APPID_RESOURCEID(IDR_EPROCALLEXT, "{4E400D16-839A-4267-ADDC-AB891F540974}")
};

CEProCallExtModule _AtlModule;


#ifdef _MANAGED
#pragma managed(push, off)
#endif

// DLL Entry Point
extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	hInstance;
	return _AtlModule.DllMain(dwReason, lpReserved);
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

// Used to determine whether the DLL can be unloaded by OLE
STDAPI DllCanUnloadNow(void)
{
	return _AtlModule.DllCanUnloadNow();
}

// Returns a class factory to create an object of the requested type
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _AtlModule.DllGetClassObject(rclsid, riid, ppv);
}

// DllRegisterServer - Adds entries to the system registry
// If you have your own custom registration step, you can use the per user registration command: regsvr32 "xxxx.dll".
//   siehe auch: DllInstall()
// eine "PerUser" installation wird typischerweise vom installations prozess initiert indem ::RegOverridePredefKey() benutzt wird.
//  z.b. durch:
//    msiexec "ALLUSERS" property
//    VisualStudio durch "LinkerSettings->General->Per-user Redirection"
//    ...
// HINWEIS:
//   durch das redirect erspart man sich das mehrfach anlegen/pflegen von unterschiedlichen .rgs files
STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	HRESULT hr = _AtlModule.DllRegisterServer();
	return hr;
}

// If you have your own custom registration step, you can use the per user registration command: regsvr32 /s /n /i:user "xxxx.dll".
//   das /i:user argument wird dann ueber die commandline args abgefragt. siehe auch: DllMain()
//   ACHTUNG: durch den /n parameter wird DllRegisterServer() gar nicht mehr aufgerufen
STDAPI DllInstall(__in BOOL bInstall, __in LPCWSTR pszCmdLine)
{
	const CString strCmdLine = pszCmdLine;

	HRESULT hr = NOERROR;
	if (0 <= strCmdLine.Find(_T("user")))
		hr = AtlSetPerUserRegistration(true);

	if(bInstall)
		hr = _AtlModule.DllRegisterServer();
	else
		hr = _AtlModule.DllUnregisterServer();

	return hr;
}

// DllUnregisterServer - Removes entries from the system registry
STDAPI DllUnregisterServer(void)
{
	HRESULT hr = _AtlModule.DllUnregisterServer();
	return hr;
}
