#pragma once

template < class T, const GUID* plibid = &CAtlModule::m_libid, WORD wMajor = 1, WORD wMinor = 0 >
class ATL_NO_VTABLE IJournalCmdBarHandlerImpl :
	public IDispatchImpl < IJournalCmdBarHandler, &__uuidof(IJournalCmdBarHandler), plibid, wMajor, wMinor >
{
public:
	BEGIN_COM_MAP(IJournalCmdBarHandlerImpl < T > )
		COM_INTERFACE_ENTRY(IJournalCmdBarHandler)
		COM_INTERFACE_ENTRY2(IDispatch, IJournalCmdBarHandler)
	END_COM_MAP()

// IJournalCmdBarHandler implementation
public:
	STDMETHOD (OnCmdBarCreate) (
		/* [in] */ IDispatch* pCmdBar,
		/* [in] */ IDispatch* pContext)
	{
		T* pT = static_cast < T* >(this);

		HRESULT hr = NOERROR;
		return hr;
	}

	STDMETHOD (OnUpdateCommandUIEnable) (
		/* [in] */ long lCmdID,
		/* [retval][out] */ BOOL* pbEnable)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;

		return hr;
	}

	STDMETHOD (OnUpdateCommandUIText) (
		/* [in] */ long lCmdID,
		/* [retval][out] */ BSTR* pbstrCaption)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;

		return hr;
	}

	STDMETHOD (OnUpdateCommandUICheck) (
		/* [in] */ long lCmdID,
		/* [retval][out] */ BOOL* pbRetC)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;

		return hr;
	}

	STDMETHOD (OnUpdateCommandUIRadio) (
		/* [in] */ long lCmdID,
		/* [retval][out] */ BOOL* pbRetC)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;

		return hr;
	}

	STDMETHOD (OnCmdBarItemClicked) (
		/* [in] */ long lCmdID,
		/* [in] */ IDispatch* pContext)
	{
		T* pT = static_cast<T*>(this);

		HRESULT hr = E_INVALIDARG;

		return hr;
	}
};
