// MFC_ATL_ClientDlg.h : header file
//

#if !defined(AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_)
#define AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg dialog
class CMFC_ATL_ClientDlg :
	public CDialog
{
// Construction
public:
	CMFC_ATL_ClientDlg(CWnd* pParent = NULL);	// standard constructor
	~CMFC_ATL_ClientDlg();						// standard destructor

// Dialog Data
	//{{AFX_DATA(CMFC_ATL_ClientDlg)
	enum { IDD = IDD_MFC_ATL_CLIENT_DIALOG };
	CButton	    m_rbListBox;
	CButton	    m_rbMessageBox;
	CButton	    m_cbUseRegUser;
	CButton	    m_cbUseRegServer;
	CEdit	    m_eUserPasswd;
	CEdit	    m_eUserName;
	CEdit	    m_eServerPort;
	CEdit	    m_eServerAddress;
	CListBox	m_lbCallList;
	CButton	    m_rbFirstLine;
	CButton	    m_rbSecondLine;
	CButton	    m_rbAllLines;
	CButton	    m_bDial;
	CEdit       m_eFromNumber;
	CEdit       m_eToNumber;
	CComboBox   m_cbServerVer;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMFC_ATL_ClientDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMFC_ATL_ClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCmdinit();
	afx_msg void OnRblistbox();
	afx_msg void OnRbmessagebox();
	afx_msg void OnUsereg4server();
	afx_msg void OnUsereg4user();
	afx_msg void OnCmddial();
	afx_msg void OnBnClickedHangup();
	afx_msg void OnCbnSelendokServerver();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	DECLARE_INTERFACE_MAP()
	DECLARE_DISPATCH_MAP()
	HRESULT OnCNCallOffering (LPDISPATCH pDisp);
	HRESULT OnDisconnect     (void);
	HRESULT OnReconnect      (void);

private:
	typedef enum {
		ssInitialize = 1,
		ssNormal,
		ssConnected
	} tState;
	void SetState                  (tState aState);
	HRESULT ReleaseApplication     ();
	BOOL    Unadvise               ();
	BSTR    FormatMessageFromModule(const _com_error& e, LPCTSTR szModule);

	ENETSNLib::IApplicationPtr m_spApp;
	DWORD                      m_dwCookie;
	enum {
		toCStrTx = 1,
		toMsgBox
	}                          m_TransferOption;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFC_ATL_CLIENTDLG_H__E6945F65_CAD1_4B97_A3AE_53D4840D4FC9__INCLUDED_)
