using System;
using System.Windows.Forms;

namespace CSNetTSC
{
	/// <summary>
	/// Zusammenfassung fr CallTreeNode.
	/// </summary>
	public class CallTreeNode : TreeNode
	{
        private ENETTSCLib.Call thisCall;
        private string thisCallName;

		public CallTreeNode(ENETTSCLib.Call call) : base()
		{
            thisCall = call;
            thisCallName = "C" + call.ID;

            Text = thisCallName;
		}

        public ENETTSCLib.Call getCall()
        {
            return thisCall;
        }
	}
}
