// MFC_ATL_Client.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MFC_ATL_Client.h"
#include "MFC_ATL_ClientDlg.h"
#include <initguid.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only CMFC_ATL_ClientApp object
CMFC_ATL_ClientApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientApp
BEGIN_MESSAGE_MAP(CMFC_ATL_ClientApp, CWinApp)
	//{{AFX_MSG_MAP(CMFC_ATL_ClientApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientApp construction
CMFC_ATL_ClientApp::CMFC_ATL_ClientApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientApp initialization
BOOL CMFC_ATL_ClientApp::InitInstance()
{
	AfxOleInit();
	AfxEnableControlContainer();

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_bRunEmbedded || cmdInfo.m_bRunAutomated)
	{
		return TRUE;
	}

	CMFC_ATL_ClientDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CMFC_ATL_ClientApp::ExitInstance()
{
	return CWinApp::ExitInstance();
}
